/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(!dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Appointment"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Appointment"] = true;
dojo.provide("epages.cartridges.de_epages.calendar.widget.Appointment");



dojo.declare(
	"epages.cartridges.de_epages.calendar.widget.Appointment",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */

		Alias:          '',
		AddressInfo:    '',
		ContactInfo:    '',
		ProductInfo:    '',
		StartDate:      '',
		EndDate:        '',
		StartDate_Time: '',
		EndDate_Time:   '',
		objectId:       '', // AppointmentId
		productId:      '',
		_StartDateTime: '',
		_EndDateTime: 	'',
		url:            '?',
		/**
		 * dojo widget properties
		 */
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.calendar.widget','templates/translation'),
		templateString:"<span>${AddressInfo.Company} ${AddressInfo.FirstName} ${AddressInfo.LastName}</span>\n",

		postMixInProperties: function () {
			this.inherited('postMixInProperties',arguments);
			// select template
			if (this.AddressInfo == '') {
				this.AddressInfo = this.translate('EMPTY_ADDRESS');
			}
			var pad = dojo.string.pad;
			var start = dojo.date.stamp.fromISOString(this.StartDate);
			this._StartDateTime = pad(start.getHours(),2) + ':' + pad(start.getMinutes(),2);
			var end = dojo.date.stamp.fromISOString(this.EndDate);
			this._EndDateTime = pad(end.getHours(),2) + ':' + pad(end.getMinutes(),2);
		},

		postCreate: function(){
			this.inherited('postCreate',arguments);
			if(this.AddressInfo){
				if(this.AddressInfo.CancelledOn){
					dojo.addClass(this.domNode,'Cancelled');
				}
				if(this.AddressInfo.AcceptedOn){
					dojo.addClass(this.domNode,'Accepted');
				}
			}
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Appointmenttimeitem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Appointmenttimeitem"] = true;
dojo.provide("epages.cartridges.de_epages.calendar.widget.Appointmenttimeitem");




dojo.declare(
	"epages.cartridges.de_epages.calendar.widget.Appointmenttimeitem",
	[epages.widget.LocalizedWidget],
	{

		/**
		 * public properties
		 */
		objectId:       '', // CalendarId
		productId:      '',
		StartDate:      '',
		EndDate:        '',
		IsBusiness:			'',
		IsBookingHours: '',
		_StartDateTime: '',
		Appointments:   [],
		url:            '?',
		isinactive:			'0',
		availableQuantity: '',

		/**
		 * dojo widget properties
		 */
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.calendar.widget','templates/translation'),
		templateString:"<tr class=\"AppointmentItem Small\">\n  <td class=\"Time\">${_StartDateTime}</td>\n  <td class=\"NumberOfDates\" dojoAttachPoint=\"numberOfDatesNode\"></td>\n  <td class=\"BookedBy\" dojoAttachpoint=\"appointmentsNode\"></td>\n</tr>\n",
		widgetsInTemplate:true,

		postMixInProperties: function () {
			this.inherited('postMixInProperties',arguments);
			var pad = dojo.string.pad;
			var start = dojo.date.stamp.fromISOString(this.StartDate);
			this._StartDateTime = pad(start.getHours(),2) + ':' + pad(start.getMinutes(),2);
		},

		postCreate: function () {
			// summary: Create instance of an Appointmentitem.
			// description: This method is used to show the list of booked resources for one day when
			// mouse-overed a day in the appointment list. To show the number of booked appointment slots
			// for this day, all booked appontments are traversed and the quantity of booked slots is
			// summed up.
			// Then the name and status of each booked appointment is listed which results in the appropiate
			// dom nodes. A dom node is marked as overbooked if more slots were booked for the day than
			// available (which is set by the stock value for the resource product).
			this.inherited('postCreate',arguments);

			// calculate sum of used slots
			var sumQuantities = 0.0;
			for( var i=0,l=this.Appointments.length ; i<l ; i++ ) {
				sumQuantities += parseFloat(this.Appointments[i].Quantity);
			}

			// create overview list
			for( var i=0,l=this.Appointments.length ; i<l ; i++ ) {
				var d = this.Appointments[i];
				d.productId = this.productId;
				d.url = this.url;
				// if number of used slots is higher than number of available ones, mark as overbooked
				if(sumQuantities > parseFloat(this.availableQuantity)){
					dojo.addClass(this.domNode,'Overbooked');
				}
				var w = new epages.cartridges.de_epages.calendar.widget.Appointment(d);
				// if any appointments for this time, list them
				if(i>0) {
					var s = document.createTextNode(", ");
					$(this.appointmentsNode).appendChild(s);
				}
				$(this.appointmentsNode).appendChild(w.domNode);
			}
			if (this.isinactive == '1') {
				if (this.inactiveNode != undefined){
					this.inactiveNode.style.display = '';
				}
				if (this.activeNode != undefined){
					this.activeNode.style.display = 'none';
				}
			}
			if(this.numberOfDatesNode){
				this.numberOfDatesNode.innerHTML = sumQuantities + ' / ' +this.availableQuantity;
			}
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Appointmentcalendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Appointmentcalendar"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.calendar.widget.Appointmentcalendar $Revision: 1.23.106.1 $

*/
dojo.provide("epages.cartridges.de_epages.calendar.widget.Appointmentcalendar");








dojo.declare(
	"epages.cartridges.de_epages.calendar.widget.Appointmentcalendar",
	epages.widget.Calendar,
	{

		/**
		 * public properties
		 */
		objectId: '', // CalendarId
		productId: '',
		datastoreId: 'Datastore',
		waitForFloating: '500',
		availableQuantity: '',
		requestedQuantity: '',
		requestedMinutes: '',

		url: '?',
		classNames: null,
		appointmentClassNames: {
			'IsLocked': 'Locked',
			'IsUsed'  : 'Used',
			'IsBusy'  : 'Busy'
		},

		_appListSmallTemplateString :	'<div class="AppointmentListSmall"><table><thead>'
			+'	<tr class="AppointmentItem Small">'
			+'		<th class="Time">{Time}</td>'
			+'		<th class="NumberOfDates">{NumberOfDates}</td>'
			+'		<th class="BookedBy">{BookedBy}</td>'
			+'	</tr></thead>'
			+'<tfoot></tfoot><tbody><tr class="NoDates"><td colspan="3">{NoDates}</td></tbody></table></div>',

		_timeoutShortList: undefined, // _onOver, _onOut, resetTimeouts
		_timeoutListDate: undefined,  // _onOver, _onOut, resetTimeouts
		_visibleFloating: undefined,  // _onOver, _onOut, resetTimeouts
		_visibleOverview: undefined,  // _onClick

		_dictionary: undefined,

		_dateFormats: null,
		_datastore: undefined,
		_monthMoveCount: undefined,
		_moveCountInterval: undefined,

		postMixInProperties: function () {
			this.inherited('postMixInProperties',arguments);
			this.classNames= [];
			this._dateFormats = {};
			this._monthMoveCount = {
				step: 0,
				amount: ''
			};
			for(var name in this.appointmentClassNames) {
				if (this.classNames[name] === undefined){
					this.classNames[name] = this.appointmentClassNames[name];
				}
			}
			if($$(this.datastoreId)){
				this._datastore = $$(this.datastoreId);
			}
			// prepare template
			
			this._dictionary = new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.calendar.widget', "templates/translation"), "auto");
			this._appListSmallTemplateString = this._dictionary.replaceLanguageTags(this._appListSmallTemplateString);
		},

		postCreate: function () {
			this.inherited('postCreate',arguments);
			this.connect(this.domNode, "onmouseover", "_onOver");
			this.connect(this.domNode, "onmouseout",  "_onOut");
			this.connect(this.domNode, "onmousedown", "_onClick");
			//change connects for increment/decrement month/year to avoid errors with reloaded content
			this.connect(this.incrementMonth ,"onmousedown", function(){
				this._countMonthMoves('month',1);
			});
			this.connect(this.incrementMonth ,"onmouseup", '_doMonthMoves');
			this.connect(this.decrementMonth ,"onmousedown", function(){
				this._countMonthMoves('month', -1);
			});
			this.connect(this.decrementMonth ,"onmouseup", '_doMonthMoves');
			this.connect(this.nextYearLabelNode ,"onclick", function(){
				this._adjustDisplay('year', 1);
			});
			this.connect(this.previousYearLabelNode ,"onclick", function(){
				this._adjustDisplay('year', -1);
			});
		},

		_countMonthMoves: function(amount,step){
			this._addMonthStep(amount,step);
			this._moveCountInterval = window.setInterval(dojo.hitch(this,function(amount,step){
				this._addMonthStep(amount,step);
			},amount,step),500);
		},

		_doMonthMoves: function(){
			window.clearInterval(this._moveCountInterval);
			this._adjustDisplay(this._monthMoveCount.amount, this._monthMoveCount.step);
			this._monthMoveCount.amount = '';
			this._monthMoveCount.step = 0;
		},

		_addMonthStep:function(amount,step){
			this._monthMoveCount.amount = amount;
			this._monthMoveCount.step = this._monthMoveCount.step + step;
			var month = dojo.date.add(this.displayMonth, this._monthMoveCount.amount, this._monthMoveCount.step);
			// Fill in localized month name
			var monthNames = dojo.date.locale.getNames('months', 'wide', 'standAlone', this.lang);
			this._setText(this.monthLabelNode, monthNames[month.getMonth()]);
		},

		_onReceiveRequest: function (result) {
			if(!result){
				return false;
			}
			var pad = dojo.string.pad;
			dojo.query(".dijitCalendarDateLabel", this.domNode).forEach(function(label, i){
				var node = this._dateNode(label);
				if(node){//in some wired cases node can be undefined
					var nodeDate = new Date(node.dijitDateValue);
					var datekey = [pad(nodeDate.getFullYear(), 4), pad(nodeDate.getMonth() + 1, 2), pad(nodeDate.getDate(), 2)].join("-");
					var dateData = result[datekey+'T00:00:00'];
					for(var key in dateData) {
						if(this.classNames[key]){
							if (dateData[key] == 1) {
								dojo.addClass(node, this.classNames[key]);
							} else {
								dojo.removeClass(node, this.classNames[key]);
							}
						}
					}
				}
			}, this);
		},

		_originalPopulateGrid: function(){
			var month = this.displayMonth;
			month.setDate(1);
			var firstDay = month.getDay();
			var daysInMonth = dojo.date.getDaysInMonth(month);
			var daysInPreviousMonth = dojo.date.getDaysInMonth(dojo.date.add(month, "month", -1));
			var today = new Date();
			var selected = this.value;

			var dayOffset = dojo.cldr.supplemental.getFirstDayOfWeek(this.lang);
			if(dayOffset > firstDay){ dayOffset -= 7; }

			// Iterate through dates in the calendar and fill in date numbers and style info
			dojo.query(".dijitCalendarDateTemplate", this.domNode).forEach(function(template, i){
				i += dayOffset;
				var date = new Date(month);
				var number, clazz = "dijitCalendar", adj = 0;

				if(i < firstDay){
					number = daysInPreviousMonth - firstDay + i + 1;
					adj = -1;
					clazz += "Previous";
				}else if(i >= (firstDay + daysInMonth)){
					number = i - firstDay - daysInMonth + 1;
					adj = 1;
					clazz += "Next";
				}else{
					number = i - firstDay + 1;
					clazz += "Current";
				}

				if(adj){
					date = dojo.date.add(date, "month", adj);
				}
				date.setDate(number);

				if(!dojo.date.compare(date, today, "date")){
					clazz = "dijitCalendarCurrentDate " + clazz;
				}

				if(!dojo.date.compare(date, selected, "date")){
					clazz = "dijitCalendarSelectedDate " + clazz;
				}

				if(this.isDisabledDate(date, this.lang)){
					clazz = "dijitCalendarDisabledDate " + clazz;
				}

				template.className =  clazz + "Month dijitCalendarDateTemplate";
				template.dijitDateValue = date.valueOf();
				var label = dojo.query(".dijitCalendarDateLabel", template)[0];
				this._setText(label, date.getDate());
			}, this);

			// Fill in localized month name
			var monthNames = dojo.date.locale.getNames('months', 'wide', 'standAlone', this.lang);
			this._setText(this.monthLabelNode, monthNames[month.getMonth()]);

			// Fill in localized prev/current/next years
			var y = month.getFullYear() - 1;
			var d = new Date();
			dojo.forEach(["previous", "current", "next"], function(name){
				d.setFullYear(y++);
				this._setText(this[name+"YearLabelNode"], d.getFullYear() );
			}, this);
		},

		_populateGrid: function (days) {
			this.inherited('_populateGrid', arguments);
			this._originalPopulateGrid();
			this.displayMonth.setMinutes(0);
			this.displayMonth.setSeconds(0);
			this.displayMonth.setHours(0);
			if(this._datastore){
				this._onReceiveRequest(this._datastore.getDateFormats({
					objectId  : this.objectId,
					startDate : this.displayMonth,
					endDate   : dojo.date.add(this.displayMonth, "day", dojo.date.getDaysInMonth(this.displayMonth)),
					available : this.availableQuantity,
					requested : this.requestedQuantity,
					requestedMinutes : this.requestedMinutes
				}));
			}
		},

		resetTimeouts: function() {
			clearTimeout(this._timeoutShortList);
		},

		_onOver: function (evt) {

			this.resetTimeouts();
			var dateNode = this._dateNode(evt.target);
			if (!dateNode){
				return;
			}
			this._timeoutListDate = dateNode.dijitDateValue;
			var x = evt.clientX + document.documentElement.scrollLeft;
			var y = evt.clientY + document.documentElement.scrollTop;
			this._timeoutShortList = setTimeout(epages.lang.hitch(this, this.showShortList, [dateNode, x, y]), Number(this.waitForFloating));
		},

		_onOut: function (evt) {
			this.resetTimeouts();
		},

		_onClick: function (evt) {
			this.resetTimeouts();

			var dateNode = this._dateNode(evt.target);
			if (!dateNode){
				return;
			}
			var dateString = dateNode.dijitDateValue;
			dojo.publish(this.id+'/select',[{date: new Date(dateString)}]);
		},

		findDateElement: function (dateString) {
			var dateNode = null;
			dojo.query(".dijitCalendarDateLabel", this.domNode).forEach(function(label, i){
				var node = this._dateNode(label);
				if (node.dijitDateValue == dateString){
					dateNode = node;
				}
			});
			return dateNode;
		},

		loadLists: function(dateString, listName) {
			if ($(listName +'_' + dateString) == null) {
				// load data from datastore
				var data = this._datastore.getDayList(new Date(Number(dateString)));

				// create floating list
				// for positioning var dateTd = this.findDateElement(dateString);
				var floatingDiv = document.createElement('div');
				floatingDiv.id = 'floating_' + dateString;
				floatingDiv.style.display = 'none';
				floatingDiv.className="AppointmentListSmallWrapper";
				floatingDiv.innerHTML=this._appListSmallTemplateString;

				$(this.domNode.parentNode).insertBefore(floatingDiv, this.domNode);

				// fill lists with data
				// filelist.setChildren(data);
				var e,d;
				for( var i=0,l=data.length ; i<l ; i++ ) {
					d = data[i];
					d.objectId = this.objectId;
					d.productId  = this.productId;
					d.url = this.url;
					d.isinactive = (dojo.date.stamp.fromISOString(d.EndDate) < new Date()) ? '1' : '0';
					d.availableQuantity = this.availableQuantity;

					if (d.IsBusiness || d.Appointments.length > 0) {
						e = document.createElement('tr');
						floatingDiv.getElementsByTagName("tbody")[0].appendChild(e);
						new epages.cartridges.de_epages.calendar.widget.Appointmenttimeitem(d, e);
					}
				}

				// remove NoDates node if empty
				var tbody=floatingDiv.getElementsByTagName("tbody")[0];
				if(tbody.lastChild.className != "NoDates" ){
					tbody.removeChild(tbody.firstChild);
				}

			}
		},

		showShortList: function(dateNode, x,y) {
			oldTooltip = $$(this._visibleFloating);

			this.loadLists(this._timeoutListDate, 'floating');
			this._visibleFloating = 'floating_' + this._timeoutListDate;

			var tooltip = $$(this._visibleFloating);
			if(tooltip !== oldTooltip){
				oldTooltip.hide();
			}

			if(tooltip === undefined) {
				tooltip = new epages.widget.Tooltip({
					tooltipArea: dateNode,
					interactive: true,
					forceOrientation: 'B',
					'class' : 'Wide Plain'
				}, $(this._visibleFloating));
				tooltip.show(x,y);
			}
		},

		_onDayClick: function(){
				this.inherited('_onDayClick',arguments);
			if (this.timer != null){
				this.timer.fillTimes(this.value);
			}
		}
});


}

if(!dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.calendar.widget.Calendar"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.calendar.widget.Calendar $Revision: 1.16 $

*/
dojo.provide("epages.cartridges.de_epages.calendar.widget.Calendar");






dojo.declare(
	"epages.cartridges.de_epages.calendar.widget.Calendar",
	epages.widget.Calendar,
	{

		/**
		 * public properties
		 */
		objectId: '', // CalendarId
		productId: '',
		containerId: '',
		availableQuantity: '',
		requestedQuantity: '',
		minOrderQuantity: '',
		timer: null,
		requestedMinutes: '',
		datastoreId: 'Datastore',
		quantityInput: undefined,

		url: '?',
		_loadedFormats: undefined,
		_loadedList:    undefined,
		_readyForClick: true, // flag to disable click events if calendar is loading
		_firstLoading: true,
		_datastore: undefined,

		postMixInProperties: function () {
			this.inherited('postMixInProperties',arguments);
			if($$(this.datastoreId)){
				this._datastore = $$(this.datastoreId);
				dojo.subscribe(this.datastoreId+'/load',this,'_onReceiveRequest');
			}
			this._loadedFormats = {};
			this._loadedList = {};
			if(this.quantityInput){
				this.connect(this.quantityInput, 'change', '_onQunatitiyInputChange');
				this.requestedQuantity = this.quantityInput.value;
			}
		},

		postCreate: function () {
			this.inherited('postCreate',arguments);
			if (this.timer != null){ 
				this.timer.fillTimes = dojo.hitch(this, '_fillTimes');
			}
		},

		getDateKey: function (date) {
			var pad = dojo.string.pad;
			return [pad(date.getFullYear(), 4), pad(date.getMonth() + 1, 2), pad(date.getDate(), 2)].join("-")+'T00:00:00';
		},

		_onReceiveRequest: function (result,month) {
			if(!result || month != dojo.date.stamp.toISOString(this.displayMonth)){ 
				return false;
			}
			//correct visible dates and times
			for(var el in result){
				if(el){
					var date1 = new Date(dojo.date.stamp.fromISOString(el));
					date1.setHours(00);
					var newString = dojo.date.stamp.toISOString(date1);
					newString = newString.substring(0,19);
					result[newString] = result[el];
					//delete result[el];
				}
			}

			this._loadedFormats[this.displayMonth] = result;
			dojo.query(".dijitCalendarDateLabel", this.domNode).forEach(function(label, i){
				var node = this._dateNode(label);
				var datekey = this.getDateKey(new Date(node.dijitDateValue));
				var dateData = result[datekey];
				if (dateData !== undefined) {
					var me = this;
					this._loadedList[datekey] = [];
					for( var i=0,iLength=dateData['DayList'].length ; i<iLength ; i++ ){
						//calculate available Quantity for this timeslot
						var availableQuantity = me.availableQuantity - dateData['DayList'][i][1];
						//check if requested Quantity is equal or higher as minOrder and if it is lower or equal than availableQuantity
						if((parseFloat(me.requestedQuantity) >= parseFloat(me.minOrderQuantity))
						&& (parseInt(me.requestedQuantity) <= parseInt(availableQuantity))){
							this._loadedList[datekey].push(dojo.date.stamp.fromISOString(dateData['DayList'][i]));
						}
					}
					if(this._loadedList[datekey] && this._loadedList[datekey].length == 0){
						dojo.addClass(node,'dijitCalendarDisabledDate');
					}else{
						dojo.removeClass(node,'dijitCalendarDisabledDate');
					}
				} else {
					dojo.addClass(node,'dijitCalendarDisabledDate');
				}
			}, this);
			dojo.publish("interactionRestrictor/permit", ["CalendarRestrictor"]);
			this._readyForClick = true;
			if(this._firstLoading){
				//fill Timer after first Loading
				this.timer.fillTimes(this.value);
				this._firstLoading = false;
				this._checkSelectedDay();  // disable because of EPG-14391
			}
		},

		_populateGrid: function (days) {
			this.inherited('_populateGrid',arguments);
			this.displayMonth.setMinutes(0);
			this.displayMonth.setSeconds(0);
			this.displayMonth.setHours(0);
			if(this._datastore){
				dojo.publish("interactionRestrictor/suspend", ["CalendarRestrictor", this.domNode.getElementsByTagName("tbody")[0]]);
				this._readyForClick = false;
				this._datastore.getDateFormatsSF({
					objectId  : this.objectId,
					startDate : this.displayMonth,
					endDate   : dojo.date.add(this.displayMonth, "day", dojo.date.getDaysInMonth(this.displayMonth)),
					available : this.availableQuantity,
					requestedMinutes : this.requestedMinutes
				});
			}
		},

		_fillTimes: function (date) {
			var dateKey = this.getDateKey(date);
			var times = this._loadedList[dateKey];
			this.timer.setTimes(times);
		},

		isDisabledDate: function(/*Date*/dateObject, /*String?*/locale){
			//disable date if there are no appointments available
			if(this._loadedList[this.getDateKey(dateObject)] && this._loadedList[this.getDateKey(dateObject)].length == 0){
				 return true;
			}
			return false; // Boolean
		},

		_onDayClick: function(/*Event*/evt){
			if(this._readyForClick){
				this.inherited('_onDayClick',arguments);
				if (this.timer != null){
					this.timer.fillTimes(this.value);
				}
			}
		},

		_onQunatitiyInputChange : function(evt){
			this.requestedQuantity = this.quantityInput.value;
			this._populateGrid();
			this.timer.fillTimes(this.value);
		},

		setRequestedMinutes: function(minutes){
			this.requestedMinutes = minutes;
			this._populateGrid();
			this.timer.fillTimes(this.value);
		},

		_checkSelectedDay: function(){
			//summary: check if selected Day is selectable if not switch to next available day in this month
			var currentDay = this.value.getDate();
			var nextAvailableDate;
			var testDate = new Date(this.value);
			if(currentDay && currentDay < 31){
				for(var i = currentDay; i <= 31; i++){
					testDate.setDate(i);
					var testDateKey = this.getDateKey(testDate);
					if(this._loadedList[testDateKey] && this._loadedList[testDateKey].length != 0){
						nextAvailableDate = testDate;
						break;
					}
				}
			}
			if(nextAvailableDate){
				this.attr('value',nextAvailableDate);
				return true;
			}
			else{
				return false;
			}
		}

});

}

if(!dojo._hasResource['epages.cartridges.de_epages.calendar.widget.Datastore']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.calendar.widget.Datastore'] = true;
dojo.provide('epages.cartridges.de_epages.calendar.widget.Datastore');





dojo.declare(
	"epages.cartridges.de_epages.calendar.widget.Datastore",
	[dijit._Widget],
	{
		/**
		 * public properties
		 */

		url          :'?',
		objectId     : undefined,

		_dayLists    : undefined,
		_dateFormatsBO : undefined,
		_dateFormatsSF : undefined,

		postMixInProperties: function () {
			this.inherited('postMixInProperties',arguments);
			this._dayLists = {};
			this._dateFormatsBO = {};
			this._dateFormatsSF = {};
		},

		getDayList: function(date){
			date = epages.localize.formatDateTime(date,epages.vars.Locale.datetimeFormat);
			if(this._dayLists[date]){ 
				return this._dayLists[date];
			}
			// load data from server
			var json = new epages.io.Json;
			var result = json.loadSync(this.url, {
				'ViewAction': 'JSON-DayList',
				'ObjectID':   this.objectId,
				'StartDate':  date
			});
			if(!result.error){
				var data = result.data;
				this._dayLists[date] = data;
				return data;
			}else{ 
				return false;
			}
		},

		getDateFormats: function(request) {
			var startDate = dojo.date.stamp.toISOString(request.startDate);
			var endDate = dojo.date.stamp.toISOString(request.endDate);
			var requestKey = request.objectId
											+':'+ startDate
											+':'+ endDate
											+':'+ request.available
											+':'+request.requestedMinutes;
			if(this._dateFormatsBO[requestKey]){
				return this._dateFormatsBO[requestKey];
			}
			else {
				var me = this;
				var json = new epages.io.Json;

				var result = json.loadSync(this.url,{
					'ViewAction': 'JSON-BO-AppointmentCalendar',
					'ObjectID':   request.objectId,
					'StartDate':  startDate,
					'EndDate':    endDate,
					'Available':  request.available,
					'RequestedMinutes' : request.requestedMinutes
					//'Requested':  request.requested
				});
				if(!result.error){
					this._dateFormatsBO[requestKey] = result.data;
					return result.data;
				}
				return false;
			}
		},

		getDateFormatsSF: function(request){
			var key = request.objectId
							+':'+dojo.date.stamp.toISOString(request.startDate)
							+':'+dojo.date.stamp.toISOString(request.endDate)
							+':'+request.available
							+':'+request.requestedMinutes;
			if(this._dateFormatsSF[key]){
				var result = this._dateFormatsSF[key];
				dojo.publish(this.id+'/load',[result,dojo.date.stamp.toISOString(request.startDate)]);
			}
			else {
				var me = this;
				var json = new epages.io.Json;
				json.loadAsync(this.url,
				function(result){
					me._dateFormatsSF[key] = result.data;
					dojo.publish(me.id+'/load',[result.data,dojo.date.stamp.toISOString(request.startDate)]);
				}
				,{
					'ViewAction': 'JSON-AppointmentCalendar',
					'ObjectID':   request.objectId,
					'StartDate':  dojo.date.stamp.toISOString(request.startDate),
					'EndDate':    dojo.date.stamp.toISOString(request.endDate),
					'Available':  request.available,
					'RequestedMinutes' : request.requestedMinutes
				});
			}
		}
});

}

if(!dojo._hasResource['epages.cartridges.de_epages.calendar.widget.Schedule']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.calendar.widget.Schedule'] = true;
dojo.provide('epages.cartridges.de_epages.calendar.widget.Schedule');







dojo.declare(
	"epages.cartridges.de_epages.calendar.widget.Schedule",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		url                :'?',
		calendarId         : 'Appointmentcalendar',
		datastoreId        : 'Datastore',
		objectId           : undefined, // id of the current business hours
		productId          : undefined, //id of the current product
		activeDate         : undefined, //current active/visible Date
		availableQuantity  : undefined, //totla quantitity of current product
		height             : '480px', //height of schedule widget
		colRatio           : '10.23', //ratio for col0 to rest of cols e.g. 1:10.23
		intervall          : '30',
		insideArea         : false,
		useDoubleHeight    : false,

		_datastore         : undefined,
		_times             : undefined,
		_appointments      : undefined,
		_now               : undefined,

		_colNode           : undefined,
		_cellNode          : undefined,
		_trNode            : undefined,
		_headThNode        : undefined,
		_hoverNode         : undefined,
		_rowsQuantity      : 0,

		_currentHoverValue : undefined,
		_currentHoverNode  : undefined,
		_startBusinessHoursMinute : undefined, 	// start time of buisness hours in minutes
		_intervallheight   : undefined,
		/**
		 * dojo widget properties
		 */
		imagePath       : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.calendar.widget','templates/translation'),
		templateString  :'<div class="Schedule Day"></div>',

		//template snippets for innerTable working with strings is in ie faster than with dom nodes
		_template: {
			'DateTableHeadTop'     : '<div class="DateTableHeadWrapper"><table class="DateTableHead"><colgroup>',
			'DateTableHeadBottomCols'  : '</colgroup>',
			'DateTableHeadBottom'  : '</table></div>',
			'ColElementTop'        : '<col ',
			'ColElementBottom'     : '></col>',
			'HeadTrTop'            : '<tr>',
			'HeadTrBottom'         : '</tr>',
			'HeadThTop'            : '<th>',
			'HeadThBottom'         : '</th>',
			'CellTop'              : '<td',
			'CellBottom'           : '</td>',
			'DateTableTop'         : '<div class="DateTableWrapper"><table class="DateTable"><colgroup>',
			'DateTableBottomCols'  : '</colgroup>',
			'DateTableBottom'      : '</table></div>',
			'TrTop'                : '<tr',
			'TrBottom'             : '</tr>',
			'ThTop'                : '<th class="Timeline">',
			'ThBottom'             : '</th>',
			'TimeTop'              : '<div class="Wrapper"><div class="Time">',
			'TimeBottom'           : '</div>',
			'WrapperBottom'        : '</div>',
			'HourTop'              : '<span class="Hour">',
			'HourBottom'           : '</span>',
			'MinutesTop'           : '<span class="Minutes">',
			'MinutesBottom'        : '</span>',
			'LockTop'              : '<div',
			'LockBottom'           : '</div>',
			'NowTop'               : '<div class="Now" style="',
			'NowBottom'            : '"></div>',
			'NewEvent'             : '', //template filled in postMixInProperties to translate language tags
			'AppointmentWrapperTop': '<div class="Wrapper" ',
			'AppointmentEventTop'  : '><div class="Event EnableHover',
			'AppointmentWrapperBottom' : '</div>',
			'AppointmentTop'       : '', //template filled in postMixInProperties to translate language tags
			'AppointmentInfoTitleTop'    : '<span class="Bold">',
			'AppointmentInfoTitleBottom'    : '</span>',
			'AppointmentInfoTop'       : '<span>',
			'AppointmentInfoBottom'    : '</span>',
			'AppointmentBottom'        : '</div></div>',
			'TTTitleTop'                    : '<tt dojoType="epages.widget.Tooltip" class="ScheduleTT" target="previous"><div class="Bold" dojoAttachPoint="ttTitleNode">',
			'TTTitleBottom'                 : '</div>',
			'TTContentTop'                  : '<div dojoAttachPoint="ttContentNode">',
			'TTContentBottom'               : '</div><br /></tt>'
		},
		_resultTable : new Array(), //table to store strings of resulting table doing only one string join at the end is faster then joining the strings every time something is added


		postMixInProperties: function () {
			this.inherited('postMixInProperties',arguments);
			this._appointments = {};
			this._times = {};
			this._now = new Date();
			this.colRatio = parseFloat(this.colRatio);
			if(this.intervall == '' || this.intervall == undefined){
				this.intervall = '30';
			}
			this.intervall = parseInt(this.intervall);
			this.connect(window, 'onresize', '_resizeWrapper');
			dojo.subscribe(this.calendarId+'/select',this,'_onCalendarSelect');
			//dojo.subscribe('Lock/change',this,'_onLockChange');
			if(this.insideArea){
				this.connect(epagesDialog,'showArea', '_onShowArea');
			}
			if(!this.useDoubleHeight && this.intervall >= 30){
				this.useDoubleHeight = true;
			}
			this._intervallheight = this.useDoubleHeight ? 40 : 20;
			//add double height classs to top of the data table
			if(this.useDoubleHeight){
				this._template['DateTableTop'] = '<div class="DateTableWrapper"><table class="DateTable IntervallDoubleHeight"><colgroup>';
			}
			//some templates need translation
			this._template['NewEvent'] = '<div class="Wrapper newAppointment"><div class="NewEvent"><div class="NewAppointmentNode">'+this.translate("NewAppointment")+'</div></div></div>';
			this._template['AppointmentTop'] = '<div class="TopLeft"><div class="TopRight"></div></div>'
									+'<div class="BottomLeft"><div class="BottomRight"></div></div>'
									+'<div class="OverlayButtons"><div class="Container">'
									+'<span class="Command DeleteButton" dojoAttachEvent="onclick:_onDeleteClick">'
									+'<img class="DeleteImage" src="'+this.imagePath+'/ico_s_delete.png" alt="'+this.translate("Delete")+'" title="'+this.translate("Delete")+'" />'+this.translate("Delete")+'</span></div></div>'
									+'<div class="Body" ><span class="StatusIcon"></span>';
		},

		_resizeWrapper:function(){
			var dateTableWrapper = epages.html.getElementsByClassName('DateTableWrapper',this.domNode);
			if(dateTableWrapper[0]){
				datetablewidth = dateTableWrapper[0].clientWidth;
				dateTableWrapper[0].style.height = this.height;
			}
			var dataTable = epages.html.getElementsByClassName('DateTable',this.domNode);
			if(dataTable[0]&& datetablewidth){
				dataTable[0].style.width = datetablewidth + "px";
			}
			var dataTableHead = epages.html.getElementsByClassName('DateTableHead',this.domNode);
			if(dataTableHead[0] && datetablewidth){
				dataTableHead[0].style.width = datetablewidth + "px";
			}
		},

		_calculateUsedRows: function(startDate,endDate){
			startDate = dojo.date.stamp.fromISOString(startDate);
			endDate = dojo.date.stamp.fromISOString(endDate);
			//check if start and end date are differnet to the active date
			var compare1 = dojo.date.compare(this.activeDate, startDate,'date');
			var compare2 = dojo.date.compare(this.activeDate, endDate,'date');
			if(compare1 != 0){
				startDate.setDate(this.activeDate.getDate());
				startDate.setMonth(this.activeDate.getMonth());
				startDate.setYear(this.activeDate.getFullYear());
				startDate.setHours(0);
				startDate.setMinutes(0);
				startDate.setSeconds(0);
			}
			if(compare2 != 0){
				endDate.setDate(this.activeDate.getDate());
				endDate.setMonth(this.activeDate.getMonth());
				endDate.setYear(this.activeDate.getFullYear());
				endDate.setHours(23);
				endDate.setMinutes(59);
				endDate.setSeconds(59);
			}
			var timeDiff = dojo.date.difference(startDate,endDate,'minute');
			var cellCount = Math.ceil(timeDiff/this.intervall);
			return cellCount;
		},

		_createInnerTable: function(){
			//this function creates the inner table of the widget
			this._startBusinessHoursMinute = undefined;
			//destroy old tooltip widget if another day is loaded
			var tooltips = epages.html.getElementsByClassName('ScheduleTT',this.domNode);
			for( var i=0,iLength=tooltips.length ; i<iLength ; i++ ){
				var widget = $$(tooltips[i].id);
				if(widget){
					widget.destroy();
				}
			}
			this.domNode.innerHTML = '';
			this._resultTable = new Array();
			this._resultTable.push(this._template['DateTableHeadTop']);

			//calculate col width with given colRatio in percentage
			var totalWidth = 100;
			var col0Width = parseFloat(totalWidth)/(this.colRatio+1);
			var remainWidth = totalWidth - col0Width;
			var colWidth = remainWidth / this._rowsQuantity;

			//create head table
			var cols = new Array;
			var headCells = new Array;
			cols.push(this._template['ColElementTop']+'style="width:'+col0Width+'%;"'+this._template['ColElementBottom']);
			for(var i = 0; i< this._rowsQuantity;i++){
				cols.push(this._template['ColElementTop']+'style="width:'+colWidth+'%;"'+this._template['ColElementBottom']);
				headCells.push(this._template['CellTop']+'>'+(i+1)+this._template['CellBottom']);
			}
			this._resultTable = this._resultTable.concat(cols);
			this._resultTable.push(this._template['DateTableHeadBottomCols']);
			this._resultTable.push(this._template['HeadTrTop']);
			this._resultTable.push(this._template['HeadThTop']);
			this._resultTable.push(this._template['HeadThBottom']);
			this._resultTable = this._resultTable.concat(headCells);
			this._resultTable.push(this._template['HeadTrBottom']);
			this._resultTable.push(this._template['DateTableHeadBottom']);
			this._resultTable.push(this._template['DateTableTop']);
			this._resultTable = this._resultTable.concat(cols);
			this._resultTable.push(this._template['DateTableBottomCols']);
			this._resultTable.push(this._template['DateTableBottomCols']);

			//create currentTime in Minutes only if acctual shown date is same as acctual date
			if(dojo.date.compare(this.activeDate,this._now,'date') == 0){
				var currentTime = this._now.getHours()*60;
				var minutes = this._now.getMinutes();
				var minutesSlotDistance = Math.floor(minutes / this.intervall) * this.intervall;
				var remainderMinutes = minutes - minutesSlotDistance;
				currentTime += minutesSlotDistance;
				minutes = remainderMinutes;
			}
			//create a table row which is not visible with the information of the width of each colum necessary for ie
			this._resultTable.push('<tr style="height:0px;">');
			this._resultTable.push('<td style="width:'+col0Width+'%;"></td>');
			for(var i = 0; i < this._rowsQuantity;i++){
					this._resultTable.push('<td style="width:'+colWidth+'%;"></td>');
			}
			this._resultTable.push('</tr>');
			//create tableRows foreach time
			for(time in this._times){
				var el = this._times[time];

				//set CSS classes for tr
				var trClasses = 'EnableHover IntervallRow';
				if(el.Minute < currentTime || dojo.date.compare(this.activeDate,this._now,'date') < 0){
					trClasses +=' Past';
				}
				if(!el.IsBookingHours){
					trClasses +=' OutsideBusinesshours';
				}
				if(el.IsBookingHours && this._startBusinessHoursMinute === undefined){
					this._startBusinessHoursMinute = el.Minute;
				}
				if(el.Minute%60 == 0 && el.Minute != 0){
					trClasses +=' Seperator';
				}
				if(el.IsOpened){
					trClasses +=' UnLocked';
				}
				if(el.IsLocked){
					trClasses +=' Locked';
				}
				this._resultTable.push(this._template['TrTop']+' class="'+trClasses+'">');

				//create cells
				//time cell
				var hour ='';
				var minute = '';
				if(el.Minute%60 == 0){
					hour = el.Minute/60;
					minute = '00';
				}
				this._resultTable.push(this._template['ThTop']);
				this._resultTable.push(this._template['TimeTop']);
				this._resultTable.push(this._template['HourTop']);
				this._resultTable.push(hour);
				this._resultTable.push(this._template['HourBottom']);
				this._resultTable.push(this._template['MinutesTop']);
				this._resultTable.push(minute);
				this._resultTable.push(this._template['MinutesBottom']);
				this._resultTable.push(this._template['TimeBottom']);

				//lock
				if(el.Minute < currentTime || dojo.date.compare(this.activeDate,this._now,'date') < 0) {
					this._resultTable.push(this._template['LockTop']+'>'+this._template['LockBottom']);
				}
				else {
					var LockingState = el.IsBusiness === 0 ? this.translate("Locked") : this.translate("Unlocked");
					this._resultTable.push(this._template['LockTop']+' class="Lock" startdate="'+el.StartDate+'" enddate="'+el.EndDate+'" isopen="'+el.IsBusiness+'" title="'+ LockingState +'">'+this._template['LockBottom']);
				}
				this._resultTable.push(this._template['WrapperBottom']);
				//now
				if(currentTime){
					if(el.Minute == currentTime){
						var height= Math.floor((minutes / this.intervall) * this._intervallheight);
						this._resultTable.push(this._template['NowTop']+(height-20)+'px;'+this._template['NowBottom']);
					}
				}
				this._resultTable.push(this._template['ThBottom']);
				//other cells
				for(var j = 0; j < this._rowsQuantity; j++){
					var cellClasses = 'Cell';
					var cellAppointment = '';
					//check if slot is valid or not
					if((j+1) > this.availableQuantity){
						cellClasses += ' Invalid';
					}
					var slotEmpty = true;
					currentSlot = 'slot'+j;
					if(el.Appointments.length != 0){
						if(this._startBusinessHoursMinute === undefined) {
							this._startBusinessHoursMinute = el.Minute;
						}
						//loop trough appointments, create items and block slots
						for(var lauf=0, iLength=el.Appointments.length; lauf<iLength; lauf++){
							var appointment = this._appointments[el.Appointments[lauf].objectId];
							if(appointment.slots == undefined){
								appointment.slots = [];
							}
							//check if currentSlot is empty
							if(slotEmpty == true){
								//check if appointment is already using this slot
								if($A(appointment.slots).exists(currentSlot)){
									slotEmpty = false;
									cellClasses += ' Used';
								}
								else{
									//check if appointment has already an item
									if(appointment.item == undefined){
										//create scheduleitem
										appointment.item = 'defined';
										cellAppointment = this._generateAppointmentCell(appointment,el);
										cellClasses +=' Used';
										slotEmpty = false;
										appointment.slots.push(currentSlot);
									}
									else{
										//block slot if appointment needs more slots
										if(appointment.slots.length == 0 || appointment.slots.length < appointment.Quantity){
											cellClasses += ' Used';
											slotEmpty = false;
											appointment.slots.push(currentSlot);
										}
									}
								}
							}
						}
					}

					if(slotEmpty == true || cellAppointment != ''){
					this._resultTable.push(this._template['CellTop']);
					if(cellAppointment != ''){
						this._resultTable.push('class="'+cellClasses+'" '+cellAppointment.cols+' '+cellAppointment.rows+'>');
						this._resultTable.push(cellAppointment.content);
					}
					if(slotEmpty == true){
						this._resultTable.push('startdate="'+el.StartDate+'" ');
						this._resultTable.push('class="'+cellClasses+'">');
					}
					this._resultTable.push(this._template['CellBottom']);
					}
				}
			this._resultTable.push(this._template['TrBottom']);
			}

			this._resultTable.push(this._template['DateTableBottom']);
			this.domNode.innerHTML= this._resultTable.join("\n");
			dojo.parser.parse(this.domNode);
			this._resizeWrapper();

			//// scroll bar position
			if(this._startBusinessHoursMinute !== undefined){
				var dateTableWrapper = epages.html.getElementsByClassName('DateTableWrapper',this.domNode);
				if(dateTableWrapper[0]){
					dateTableWrapper[0].scrollTop = Math.floor((this._startBusinessHoursMinute / this.intervall) * this._intervallheight);
				}
			}
			dojo.publish("interactionRestrictor/permit", ["ScheduleRestrictor"]);
		},

		_generateAppointmentCell:function(appointment,el){
			//generate Cell for appointment with adressinfo if defined and calculate used rows and cols
			var accepted = '';
			if(appointment.AddressInfo.AcceptedOn){
				accepted = ' Accepted';
			}
			var cellCount = this._calculateUsedRows(appointment.StartDate,appointment.EndDate);
			startDate = dojo.date.stamp.fromISOString(appointment.StartDate);
			endDate = dojo.date.stamp.fromISOString(appointment.EndDate);
			//check startMinute of appointment
			var minutesAppointment = startDate.getHours()*60 + startDate.getMinutes();

			// Are current and start date at the same day
			var isSameDay = !dojo.date.compare(startDate, endDate, 'date');

			if(cellCount != 0 || cellCount != 1){
				if(minutesAppointment > el.Minute && isSameDay){
					//block one cell more if appointment is out of standard alignment
					var cellRowspan = ' rowspan="'+(cellCount+1)+'"';
				}
				else{
					var cellRowspan = ' rowspan="'+cellCount+'"';
				}
			}
			//set Adress Info
			if(appointment.AddressInfo){
				var nameStringArray = [];
				if(appointment.AddressInfo.Company){
					nameStringArray.push(appointment.AddressInfo.Company+',');
				}
				if(appointment.AddressInfo.Title){
					nameStringArray.push(appointment.AddressInfo.Title);
				}
				if(appointment.AddressInfo.FirstName){
					nameStringArray.push(appointment.AddressInfo.FirstName);
				}
				if(appointment.AddressInfo.MiddleName){
					nameStringArray.push(appointment.AddressInfo.MiddleName);
				}
				if(appointment.AddressInfo.LastName){
					nameStringArray.push(appointment.AddressInfo.LastName);
				}

				//set infoTitleNode
				var nameString = nameStringArray.join(' ') + " ";
				//setInfoContentNode
				var addressStringArray = [];
				if(appointment.AddressInfo.EMail){
					addressStringArray.push(appointment.AddressInfo.EMail);
				}
				if(appointment.AddressInfo.Phone){
					addressStringArray.push(appointment.AddressInfo.Phone);
				}
				var addressString = addressStringArray.join(', ');
				if(appointment.AddressInfo.Comment){
					addressString += ', '+this.translate('Comment')+': '+appointment.AddressInfo.Comment;
				}

				var dayDiff = dojo.date.difference(startDate,endDate,'day');
				var startTimeHours = startDate.getHours();
				var startTimeMinutes = startDate.getMinutes();
				var endTimeHours = endDate.getHours();
				var endTimeMinutes = endDate.getMinutes();
				var _startTime = ' ';
				var _endTime = ' ';
				if(dayDiff != 0){
					_startTime = epages.localize.formatDateTime(startDate)+' ';
					_endTime = epages.localize.formatDateTime(endDate)+' ';
				}
				if(startTimeHours < 10){
					startTimeHours = '0'+startTimeHours;
				}
				if(startTimeMinutes < 10){
					startTimeMinutes = '0'+startTimeMinutes;
				}
				if(endTimeHours < 10){
					endTimeHours = '0'+endTimeHours;
				}
				if(endTimeMinutes < 10){
					endTimeMinutes = '0'+endTimeMinutes;
				}
				_startTime += startTimeHours+':'+startTimeMinutes;
				_endTime += endTimeHours+':'+endTimeMinutes;

				//set ttTitleNode
				var ttTitleString  = _startTime+' - '+_endTime;
				ttTitleString += ' '+nameStringArray.join(' ');
				//set ttContentNode
				var ttContentString = addressStringArray.join('<br />');
				if(appointment.AddressInfo.Comment){
					ttContentString += '<br />'+this.translate('Comment')+': '+appointment.AddressInfo.Comment;
				}
				if(appointment.AddressInfo.CustomerComment){
					ttContentString += '<br />'+this.translate('UserComment')+': '+appointment.AddressInfo.CustomerComment;
				}
				//set AcceptedOn CancelledOn
				if(appointment.AddressInfo.AcceptedOn) {
					if(!appointment.AddressInfo.CancelledOn){
						ttContentString += '<br />'+this.translate('Status')+': <b>'+this.translate('DateAccepted')+'</b>';
					}
				}
				if(!appointment.AddressInfo.AcceptedOn){
					ttContentString += '<br />'+this.translate('Status')+': <b>'+this.translate('DateUnconfirmed')+'</b>';
				}
			}

			//check if  is out of standard alignment and correct position
			var diffPixels = Math.floor(((minutesAppointment - el.Minute) /  (this.intervall /4)) * 10);
			if(diffPixels == undefined || diffPixels == 'NaN'){
				diffPixels = 0;
			}
			// Recalculate offset if appointment goes over more than one day
			var	diffElemPixels = isSameDay ? diffPixels : 0;

			return {
				'rows' : cellRowspan ? cellRowspan: '',
				'cols' : ' colspan="'+appointment.Quantity+'"',
				'content' : this._template['AppointmentWrapperTop']+'style="margin-top:'+diffElemPixels+'px;"'+this._template['AppointmentEventTop']+accepted+'" style="height: '
				+ (cellCount*this._intervallheight) +'px;" appointmentid="'+appointment.objectId+'">'
				+this._template['AppointmentTop']
				+this._template['AppointmentInfoTitleTop']+nameString
				+this._template['AppointmentInfoTitleBottom']
				+this._template['AppointmentInfoTop']+addressString
				+this._template['AppointmentInfoBottom']
				+this._template['AppointmentBottom']
				+this._template['TTTitleTop']+ttTitleString
				+this._template['TTTitleBottom']
				+this._template['TTContentTop']+ttContentString
				+this._template['TTContentBottom']
				+this._template['AppointmentWrapperBottom']
			};
		},

		changeDay:function(date){
			dojo.publish("interactionRestrictor/suspend", ["ScheduleRestrictor", this.domNode]);
			this._rowsQuantity = 0;
			if(this.activeDate != date){
				this.activeDate = date;
			}
			var dayList = this._datastore.getDayList(date);
			if(dayList){

				this._now = new Date( dayList[0].CurrentDateTime.replace(/-/g,'/').replace(/T/g,' ') );

				for( var i=0,iLength=dayList.length ; i<iLength ; i++ ){
					//check requested quantity for acctual Time Slot
					var quantityForTime = 0;
					//parse Appointments
					for( var j=0,jLength=dayList[i].Appointments.length ; j<jLength ; j++ ){
						quantityForTime += parseInt(dayList[i].Appointments[j].Quantity);
						if(!this._appointments[dayList[i].Appointments[j].objectId]){
							this._appointments[dayList[i].Appointments[j].objectId] = dayList[i].Appointments[j];
							if(this._appointments[dayList[i].Appointments[j].objectId].slots){
								this._appointments[dayList[i].Appointments[j].objectId].slots = undefined;
							}
							if(this._appointments[dayList[i].Appointments[j].objectId].item){
								this._appointments[dayList[i].Appointments[j].objectId].item = undefined;
							}
						}
						else{
							if(this._appointments[dayList[i].Appointments[j].objectId].slot){
								this._appointments[dayList[i].Appointments[j].objectId].slot = [];
							}
						}
					}
					if(this._rowsQuantity < quantityForTime){
						this._rowsQuantity = quantityForTime;
					}
					if(this._rowsQuantity < dayList[i].Appointments.length){
						this._rowsQuantity = dayList[i].Appointments.length;
					}
					this._times[dayList[i].Minute] = dayList[i];
				}
				if(this._rowsQuantity < this.availableQuantity){
					this._rowsQuantity = this.availableQuantity;
				}
				this._createInnerTable();
			}
			else{
				console.warn('unable to load daylist from Server');
			}
		},

		postCreate: function(){
			this.inherited('postCreate',arguments);
			if($$(this.datastoreId)){
				this._datastore = $$(this.datastoreId);
			}
			if(!this.activeDate){
				this.activeDate = new Date();
			}
			if(typeof(this.activeDate) == 'string'){
				this.activeDate = new Date(this.activeDate);
			}
			//load acctual day and appointments, but use other thread to avoid total blocking inside ie
				dojo.addOnLoad(dojo.hitch(this,function(){
					dojo.publish("interactionRestrictor/suspend", ["ScheduleRestrictor", this.domNode]);
					window.setTimeout(dojo.hitch(this,function(){
						this.changeDay(this.activeDate);
					}),10);
					this._resizeWrapper();
				}));
				this.connect(this.domNode,'onclick', '_onSchedulerClick');
				this.connect(this.domNode,'mouseover', '_onSchedulerMouseOver');
		},

		startup: function(){
			this.inherited('startup',arguments);
			this._resizeWrapper();
		},

		_onCalendarSelect: function(opt){
			//if another day on calendar was selected clear appointments and times and load day
			this._appointments = null;
			this._appointments = {};
			this._times = null;
			this._times = {};
			this.changeDay(opt.date);
		},

		_onShowArea: function(opt){
			this._resizeWrapper();
		},

		_onLockChange: function(opt){
			//if lock change was succesfull add/remove Css class on parent table row
			var lock = $$(opt.id);
			var tableRow = lock.domNode.parentNode.parentNode.parentNode.parentNode;
					if(opt.isOpen == true){
						tableRow.setAttribute('title',this.translate("Locked"));
						dojo.addClass(tableRow,'UnLocked');
						dojo.removeClass(tableRow,'Locked');
					}
					else{
						tableRow.setAttribute('title',this.translate("Unlocked"));
						dojo.addClass(tableRow,'Locked');
						dojo.removeClass(tableRow,'UnLocked');
					}
		},

		_onClickNewAppointment: function(startDate){
			epages.locationHref('?ViewAction=MBO-ViewNewAppointment&ObjectID='+this.productId +'&StartDate='+startDate);
		},

		_onSchedulerClick: function(evt){
			var targetNode = evt.target;
			if(dojo.hasClass(targetNode,'NewAppointmentNode')){
				var cell = targetNode.parentNode.parentNode.parentNode;
				this._onClickNewAppointment(cell.getAttribute('startdate'));

			}
			if(dojo.hasClass(targetNode,'Lock')){
				this._onClickLock(targetNode);
			}
			//check if a cell was clicked
			/*if(dojo.hasClass(targetNode,'Cell')){
				if(dojo.hasClass(targetNode,'Used')){
					//console.debug('appointment Clicked');
				}
				else{
					//console.debug('empty Cell Clicked');
				}
			}*/
			if(dojo.hasClass(targetNode,'BottomRight') || dojo.hasClass(targetNode,'Body') || dojo.hasClass(targetNode,'BottomLeft')
			|| dojo.hasClass(targetNode,'StatusIcon')|| dojo.hasClass(targetNode,'TopRight')|| dojo.hasClass(targetNode,'TopLeft')){
				if(dojo.hasClass(targetNode.parentNode,'Event')){
					var eventNode = targetNode.parentNode;
				}
				if(dojo.hasClass(targetNode.parentNode.parentNode,'Event')){
					var eventNode = targetNode.parentNode.parentNode;
				}
				if(eventNode){
					var appointmentId = eventNode.getAttribute('appointmentid');
					if(appointmentId){
						epages.locationHref(this.url+'ViewAction=MBO-ViewGeneral&ObjectID='+appointmentId);
					}
				}
			}
			if(dojo.hasClass(targetNode,'DeleteButton')){
				var appointmentId = targetNode.parentNode.parentNode.parentNode.getAttribute('appointmentid');
				if(appointmentId){
						epages.locationHref(this.url+'ChangeAction=Delete&ChangeObjectID='+appointmentId+'&ObjectID='+this.productId);
					}
			}
			if(dojo.hasClass(targetNode,'DeleteImage')){
				var appointmentId = targetNode.parentNode.parentNode.parentNode.parentNode.getAttribute('appointmentid');
				if(appointmentId){
						epages.locationHref(this.url+'ChangeAction=Delete&ChangeObjectID='+appointmentId+'&ObjectID='+this.productId);
					}
			}

		},

		_onSchedulerMouseOver: function(evt){
			var targetNode = evt.target;
			if(targetNode){
				if(this._currentHoverNode && !dojo.hasClass(targetNode,'NewAppointmentNode')){
					this._currentHoverNode.innerHTML = '';
				}
				if(!dojo.hasClass(targetNode,'Used') && dojo.hasClass(targetNode,'Cell')){
					targetNode.innerHTML = this._template['NewEvent'];
					this._currentHoverNode = targetNode;
				}
			}
		},

		_onClickLock: function(node){
			var isopen = node.getAttribute('isopen');
			
			var json = new epages.io.Json();
			var output = json.loadSync(this.url, {
				ObjectID:       this.objectId,
				ChangeAction:   isopen == 1 ? 'LockPeriod' : 'UnlockPeriod',
				ViewAction:     'JSONViewResponse',
				StartDate:      node.getAttribute('startdate'),
				EndDate:        node.getAttribute('enddate')
			});
			if(!output.error){
				var tableRow = node.parentNode.parentNode.parentNode;
				if(isopen == 1){
					node.setAttribute('isopen',0);
					node.setAttribute('title',this.translate("Locked"));
					dojo.addClass(tableRow,'Locked');
					dojo.removeClass(tableRow,'UnLocked');
				}
				else{
					node.setAttribute('isopen',1);
					node.setAttribute('title',this.translate("Unlocked"));
					dojo.addClass(tableRow,'UnLocked');
					dojo.removeClass(tableRow,'Locked');
				}
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Timeselector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Timeselector"] = true;
dojo.provide("epages.widget.Timeselector");




dojo.declare(
	"epages.widget.Timeselector",
	[dijit._Widget, dijit._Templated],
	{

		/**
		 * public properties
		 */
		templateString:"<div class=\"Timeselector\">\n  <div class=\"Date\" dojoAttachPoint=\"dateNode\">\n\n  </div>\n  <div class=\"TimesContainer\" dojoAttachPoint=\"timesContainerNode\">\n    <div class=\"Times\" dojoAttachpoint=\"timesNode\">\n    </div>\n  </div>\n</div>\n",
		delta:     '5', // String - increment is 5 minutes by default
		value:     '',

		_selected: undefined,

		valuePattern:   epages.vars.Locale.datetimeFormat || "%d.%m.%y %H:%M", // String - epages datetime pattern
		displayPattern: epages.vars.Locale.timeFormat     || "%H:%M", // String - epages time pattern

		postMixInProperties: function() {
			// create dojo datetime pattern
			if (typeof this.value == 'string'){
				this.value = epages.localize.parseDateTime(this.value, this.valuePattern);
			}
			if (typeof this.delta == 'string'){
				this.delta = new Number(this.delta);
			}
			if (this.delta<=0){
				this.delta=30;
			}
		},

		postCreate: function() {
			this.inherited('postCreate', arguments);
			var date = this.value;
			this.value = null;
			this.setValue('value',date);
		},

		getValue: function() {
			// summary:
			//    returns the value as a date object, day is 1970-01-01
			return this.value;
		},

		setValue: function(/*Date*/date) {
			if (date === undefined){
				date = new Date();
			}else if (typeof date == "string"){
				date = epages.localize.parseDateTime(date, this.valuePattern);
			}

			if(!this.value || dojo.date.compare(date, this.value)){
				this.value = new Date(date);
				this.fillTimes(date);
				this.domNode.value = date == null ? undefined : date.valueOf();
			}
			if(this.value){
				this.dateNode.innerHTML = epages.localize.formatDateTime(this.value);
			}
		},

		fillTimes: function (date) {
			// summary: fill new options
			var date = new Date(this.value);
			date.setHours(0,0,0,0);
			this.dateNode.innerHTML = epages.localize.formatDateTime(date);
			var end = dojo.date.add(date, 'day', 1);
			var dates = [];
			while (date<end) {
				dates.push(date);
				date = dojo.date.add(date,'minute',this.delta);
			}
			this.setTimes(dates);
		},

		setTimes: function (opts) {
			this.dateNode.innerHTML = epages.localize.formatDateTime(this.value);
			var node = this.timesNode;
			// remove children
			while(node.firstChild){ node.removeChild(node.firstChild); }
			// add new options
			var lastCompare = undefined;
			var selected = false;
			var alternate = 0;
			dojo.forEach(opts, function (date) {
				o=document.createElement("div");
				o.innerHTML = epages.localize.formatDateTime(date, this.displayPattern);
				o.setAttribute('value',date.valueOf());
				if (!dojo.date.compare(this.value, date)){
					dojo.addClass(o,'Selected');
					this._selected = o;
					selected = true;
				}
				if(lastCompare == 1 && dojo.date.compare(this.value, date) == -1){
					dojo.addClass(o,'Selected');
					this._selected = o;
					this.value = date;
					selected = true;
				}
				lastCompare = dojo.date.compare(this.value, date);
				if(alternate){
					dojo.addClass(o,'Alternate');
				}
				node.appendChild(o);
				this.connect(o,'onclick', 'onChange');
				alternate=1-alternate;
			}, this);
			if(selected == false && lastCompare){
				if(lastCompare == 1){
					node.lastChild.selected = true;
					dojo.addClass(node.lastChild,'Selected');
					this._selected = node.lastChild;
					this.value = opts[opts.length-1];
				}
				else{
					dojo.addClass(node.firstChild,'Selected');
					this._selected = node.firstChild;
					node.firstChild.selected = true;
					this.value = opts[0];
				}
			}
		},

		onChange: function (evt) {
			var target = evt.currentTarget;
			dojo.removeClass(this._selected,'Selected');
			dojo.addClass(target,'Selected');
			this._selected = target;
			this.value = new Date(Number(target.getAttribute('value')));
			dojo.publish(this.id + '/onChange', [this.value]);
		}
	}
);

}

